| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Private Member Functions | Private Attributes | List of all members
Genfun::GaudiMathImplementation::GSLSplineInteg Class Reference

`#include <GaudiMath/Splines.h>`

Inheritance diagram for Genfun::GaudiMathImplementation::GSLSplineInteg:
[legend]
Collaboration diagram for Genfun::GaudiMathImplementation::GSLSplineInteg:
[legend]

## Public Types
typedef SplineBase::Data1D | Data1D
typedef SplineBase::Data2D | Data2D

## Public Member Functions
| GSLSplineInteg (const Data1D &x, const Data1D &y, const GaudiMath::Interpolation::Type type, const double low=0)
| mandatory macro from CLHEP/GenericFunctions More...
| GSLSplineInteg (const Data2D &data, const GaudiMath::Interpolation::Type type, const double low=0)
| constructor from data vector More...
template<class DATAX , class DATAY >
| GSLSplineInteg (const GaudiMath::Interpolation::Type type, DATAX begin_x, DATAX end_x, DATAY begin_y, const double low)
| templated constructor in the spirit of STL-algorithms More...
template<class DATA >
| GSLSplineInteg (const GaudiMath::Interpolation::Type type, DATA &&begin, DATA &&end, const double low)
| templated constructor from the sequence of pairs as sequence of pairs the class TabulatedProperty can be used More...
| GSLSplineInteg (const SplineBase &, const double low=0)
| constructor from base More...
| GSLSplineInteg (const GSLSplineInteg &)
| copy constructor More...
| ~GSLSplineInteg () override
| destructor More...
double | operator() (double a) const override
| main method: evaluate the function More...
double | operator() (const Argument &x) const override
| main method: evaluate the function More...
unsigned int | dimensionality () const override
bool | hasAnalyticDerivative () const override
| Does this function have an analytic derivative? More...
Genfun::Derivative | partial (unsigned int i) const override
| Derivatives. More...
const SplineBase & | spline () const
| acess to the spline function More...
| operator const SplineBase & () const
| cast operator to the spline function More...

## Private Member Functions
| GSLSplineInteg ()=delete
| default construtor is disabled ; More...
GSLSplineInteg & | operator= (const GSLSplineInteg &)=delete
| assignement operator is disabled ; More...

## Private Attributes
SplineBase | m_spline
double | m_low

## Detailed Description

Definition at line 551 of file Splines.h.

## Member Typedef Documentation

typedef SplineBase::Data1D Genfun::GaudiMathImplementation::GSLSplineInteg::Data1D

Definition at line 554 of file Splines.h.

typedef SplineBase::Data2D Genfun::GaudiMathImplementation::GSLSplineInteg::Data2D

Definition at line 555 of file Splines.h.

## Constructor & Destructor Documentation

Genfun::GaudiMathImplementation::GSLSplineInteg::GSLSplineInteg | ( | const Data1D & | x,
|  | const Data1D & | y,
|  | const GaudiMath::Interpolation::Type | type,
|  | const double | low = `0`
| ) |  |

mandatory macro from CLHEP/GenericFunctions

constructor from vectors and type

constructor from vectors and type

Data1D x = .. ;
Data1D y = .. ;
const AbsFunction& func =
GSLSplineInteg( x , y , GaudiMath::Interpolation::Cspline , -1 ) ;
const double value = 1 ;
const double result = func( value ) ;

Parameters

  x | vector of x
  y | vector of y
  type | interpolation type
  low | low integration limit

Data1D x = .. ;
Data1D y = .. ;
const AbsFunction& func =
GSLSplineInteg( x , y , GaudiMath::Interpolation::Cspline , -1 ) ;
const double value = 1 ;
const double result = func( value ) ;

Parameters

  x | vector of x
  y | vector of y
  type | interpolation type

Definition at line 544 of file Splines.cpp.

548 : AbsFunction ( )
549 , m_spline ( x , y , type )
550 , m_low ( low )
551 {}
gaudirun.type
string type
Definition: gaudirun.py:151
Genfun::GaudiMathImplementation::GSLSplineInteg::m_spline
SplineBase m_spline
Definition: Splines.h:696
Genfun::GaudiMathImplementation::GSLSplineInteg::m_low
double m_low
Definition: Splines.h:697

Genfun::GaudiMathImplementation::GSLSplineInteg::GSLSplineInteg | ( | const Data2D & | data,
|  | const GaudiMath::Interpolation::Type | type,
|  | const double | low = `0`
| ) |  |

constructor from data vector

Data2D data = ... ;
const AbsFunction& func =
GSLSplineInteg( data , GaudiMath::Interpolation::Cspline , -1 );
const double value = 1 ;
const double result = func( value ) ;

Parameters

  data | vector of (x,y) pairs
  type | interpolation type
  low | low integration limit

Data2D data = ... ;
const AbsFunction& func =
GSLSplineInteg( data , GaudiMath::Interpolation::Cspline , -1 );
const double value = 1 ;
const double result = func( value ) ;

Parameters

  data | vector of (x,y) pairs
  type | interpolation type

Definition at line 575 of file Splines.cpp.

578 : AbsFunction ()
579 , m_spline ( data , type )
580 , m_low ( low )
581 {}
gaudirun.type
string type
Definition: gaudirun.py:151
Genfun::GaudiMathImplementation::GSLSplineInteg::m_spline
SplineBase m_spline
Definition: Splines.h:696
Genfun::GaudiMathImplementation::GSLSplineInteg::m_low
double m_low
Definition: Splines.h:697
template<class DATAX , class DATAY >

Genfun::GaudiMathImplementation::GSLSplineInteg::GSLSplineInteg | ( | const GaudiMath::Interpolation::Type | type,
|  | DATAX | begin_x,
|  | DATAX | end_x,
|  | DATAY | begin_y,
|  | const double | low
| ) |  |
| inline

templated constructor in the spirit of STL-algorithms

It is assumed that vector "y" has tehlength AT LEAST as long as "x"

SEQURNCE1 x = .. ;
SEQUENCE2 y = .. ;
const AbsFunction& func =
GSLSpline( GaudiMath::Interpoaltion::Cspline ,
x.begin () ,
x.end () ,
y.begin () );
const double value = 1 ;
const double result = func( value ) ;

Parameters

  begin_x | begin of X-sequence
  end_x | end of X-sequence
  begin_Y | begin of Y-sequence
  type | interpolation type
  low | low integration limit

Definition at line 637 of file Splines.h.

642 : AbsFunction ( )
643 , m_spline ( type , begin_x , end_x , begin_y )
644 , m_low ( low )
645 {}
gaudirun.type
string type
Definition: gaudirun.py:151
Genfun::GaudiMathImplementation::GSLSplineInteg::m_spline
SplineBase m_spline
Definition: Splines.h:696
Genfun::GaudiMathImplementation::GSLSplineInteg::m_low
double m_low
Definition: Splines.h:697
template<class DATA >

Genfun::GaudiMathImplementation::GSLSplineInteg::GSLSplineInteg | ( | const GaudiMath::Interpolation::Type | type,
|  | DATA && | begin,
|  | DATA && | end,
|  | const double | low
| ) |  |
| inline

templated constructor from the sequence of pairs as sequence of pairs the class TabulatedProperty can be used

Parameters

  begin | begin of sequence of pairs
  end | end of sequence of pairs
  type | interpolation type
  low | low integration limit

Definition at line 660 of file Splines.h.

664 : m_spline ( type , std::forward<DATA>(begin) , std::forward<DATA>(end) )
665 , m_low ( low )
666 {}
begin
auto begin(reverse_wrapper< T > &w)
Definition: reverse.h:45
gaudirun.type
string type
Definition: gaudirun.py:151
end
auto end(reverse_wrapper< T > &w)
Definition: reverse.h:47
Genfun::GaudiMathImplementation::GSLSplineInteg::m_spline
SplineBase m_spline
Definition: Splines.h:696
Genfun::GaudiMathImplementation::GSLSplineInteg::m_low
double m_low
Definition: Splines.h:697

Genfun::GaudiMathImplementation::GSLSplineInteg::GSLSplineInteg | ( | const SplineBase & | right,
|  | const double | low = `0`
| ) |  |

constructor from base

constructor from SplineBase

Definition at line 588 of file Splines.cpp.

590 : AbsFunction ()
591 , m_spline ( right )
592 , m_low ( low )
593 {}
Genfun::GaudiMathImplementation::GSLSplineInteg::m_spline
SplineBase m_spline
Definition: Splines.h:696
Genfun::GaudiMathImplementation::GSLSplineInteg::m_low
double m_low
Definition: Splines.h:697

Genfun::GaudiMathImplementation::GSLSplineInteg::GSLSplineInteg | ( | const GSLSplineInteg & | right | ) |

copy constructor

Definition at line 600 of file Splines.cpp.

601 : AbsFunction ()
602 , m_spline ( right )
603 , m_low ( right.m_low )
604 {}
std::right
T right(T...args)
Genfun::GaudiMathImplementation::GSLSplineInteg::m_spline
SplineBase m_spline
Definition: Splines.h:696
Genfun::GaudiMathImplementation::GSLSplineInteg::m_low
double m_low
Definition: Splines.h:697

Genfun::GaudiMathImplementation::GSLSplineInteg::~GSLSplineInteg | ( |  | ) |
| override

destructor

Definition at line 610 of file Splines.cpp.

610 {}

Genfun::GaudiMathImplementation::GSLSplineInteg::GSLSplineInteg | ( |  | ) |
| private delete

default construtor is disabled ;

## Member Function Documentation

unsigned int Genfun::GaudiMathImplementation::GSLSplineInteg::dimensionality | ( |  | ) | const
| inline override

Definition at line 679 of file Splines.h.

679 { return 1 ; }

bool Genfun::GaudiMathImplementation::GSLSplineInteg::hasAnalyticDerivative | ( |  | ) | const
| inline override

Does this function have an analytic derivative?

Definition at line 681 of file Splines.h.

681 { return true ; }

Genfun::GaudiMathImplementation::GSLSplineInteg::operator const SplineBase & | ( |  | ) | const
| inline

cast operator to the spline function

Definition at line 688 of file Splines.h.

688 { return spline() ; }
Genfun::GaudiMathImplementation::GSLSplineInteg::spline
const SplineBase & spline() const
acess to the spline function
Definition: Splines.h:686

double Genfun::GaudiMathImplementation::GSLSplineInteg::operator() | ( | double | a | ) | const
| override

main method: evaluate the function

Definition at line 614 of file Splines.cpp.

615 { return m_spline.integ ( m_low , x ) ; }
Genfun::GaudiMathImplementation::SplineBase::integ
double integ(const double a, const double b) const
evaluate the integral on [a,b]
Definition: Splines.cpp:171
Genfun::GaudiMathImplementation::GSLSplineInteg::m_spline
SplineBase m_spline
Definition: Splines.h:696
Genfun::GaudiMathImplementation::GSLSplineInteg::m_low
double m_low
Definition: Splines.h:697

double Genfun::GaudiMathImplementation::GSLSplineInteg::operator() | ( | const Argument & | x | ) | const
| override

main method: evaluate the function

Definition at line 617 of file Splines.cpp.

618 { return m_spline.integ ( m_low , x[0] ) ; }
Genfun::GaudiMathImplementation::SplineBase::integ
double integ(const double a, const double b) const
evaluate the integral on [a,b]
Definition: Splines.cpp:171
Genfun::GaudiMathImplementation::GSLSplineInteg::m_spline
SplineBase m_spline
Definition: Splines.h:696
Genfun::GaudiMathImplementation::GSLSplineInteg::m_low
double m_low
Definition: Splines.h:697

GSLSplineInteg& Genfun::GaudiMathImplementation::GSLSplineInteg::operator= | ( | const GSLSplineInteg & |  | ) |
| private delete

assignement operator is disabled ;

Genfun::Derivative Genfun::GaudiMathImplementation::GSLSplineInteg::partial | ( | unsigned int | i | ) | const
| override

Derivatives.

Definition at line 624 of file Splines.cpp.

625 {
626 if ( i >= 1 )
627 {
628 const AbsFunction& aux = GaudiMath::Constant( 0.0 , 1 ) ;
629 return Genfun::FunctionNoop( &aux ) ;
630 }
631 const AbsFunction& aux = GSLSpline( *this ) ;
632 return Genfun::FunctionNoop( &aux ) ;
633 }
ana.i
list i
Definition: ana.py:128
GaudiMath::Constant
Genfun::GaudiMathImplementation::Constant Constant
Definition: GaudiMath.h:27

const SplineBase& Genfun::GaudiMathImplementation::GSLSplineInteg::spline | ( |  | ) | const
| inline

acess to the spline function

Definition at line 686 of file Splines.h.

686 { return m_spline ; }
Genfun::GaudiMathImplementation::GSLSplineInteg::m_spline
SplineBase m_spline
Definition: Splines.h:696

## Member Data Documentation

double Genfun::GaudiMathImplementation::GSLSplineInteg::m_low
| private

Definition at line 697 of file Splines.h.

SplineBase Genfun::GaudiMathImplementation::GSLSplineInteg::m_spline
| private

Definition at line 696 of file Splines.h.

The documentation for this class was generated from the following files:

- GaudiGSL/GaudiMath/Splines.h
- GaudiGSL/src/Lib/Splines.cpp